//-----------------------------------------------------------------------------
// DIRECTPAC.CPP - (c)2001 by Andr Knecke
//-----------------------------------------------------------------------------
// Header for DirectPac
//-----------------------------------------------------------------------------

#ifndef __DIRECTPAC_H__
#define __DIRECTPAC_H__

//-----------------------------------------------------------------------------
// Global Header-Includes
//-----------------------------------------------------------------------------
#include <d3d8.h>
#include <d3dx8core.h>
#include <d3dx8tex.h>

//-----------------------------------------------------------------------------
// Global Variables
//-----------------------------------------------------------------------------
#define NUMTEXTURES 22
extern LPDIRECT3DTEXTURE8 ppTexture[NUMTEXTURES];

extern int x;
extern int dir;

extern bool keys[256];
extern bool active;

extern HWND hWnd;
extern WNDCLASSEX wc;

extern bool fs;

// Player-Structure:
struct Player {
	int xpos, ypos;			// Actual Position
	int dir,				// Actual Direction
		nextdir;			// Wished Direction

	bool flip;				// Tex0/1234

	float delay, attackdelay; // Time Before Next Move...
	float lastmove;			// When Did We Move Him For The Last Time
	float lastpowerup;		// When Did He Take Up The Last PowerUp
	
	int lives;				// How Many Lives Are Left
	int score;				// Score?!

};

// Enemy-Structure:
struct Enemy {
	bool alive;
	int xpos, ypos, dir;
	int texture;
	int mode;				// 1= rand, 2 = fear, 3 = attack
};





//-----------------------------------------------------------------------------
// Global Functions
//-----------------------------------------------------------------------------

// Directgraphics.cpp
extern bool CreateDirectGraphicsWindow(char* title, int width, int height, int bits, bool fullscreen);
extern void KillDirectGraphicsWindow();
extern LPDIRECT3DTEXTURE8 LoadTexture(char *filename);
extern HRESULT BltSprite( RECT *pDestRect, LPDIRECT3DTEXTURE8 pSrcTexture, RECT *pSrcRect, DWORD dwFlags);
extern bool Render();

// Main.cpp
extern void Init();
extern void Draw(); 


#endif