//-----------------------------------------------------------------------------
// MAIN.CPP - (c)2001 by Andr Knecke
//-----------------------------------------------------------------------------
// Main-Functions for DirectPac
//-----------------------------------------------------------------------------


//-----------------------------------------------------------------------------
// Includes
//-----------------------------------------------------------------------------
#include "directpac.h"
#include "resource.h"
#include "timer.h"

//-----------------------------------------------------------------------------
// Global variables
//-----------------------------------------------------------------------------
HWND hWnd = NULL;						// Window-Handle
WNDCLASSEX wc;							// Window-Class

bool keys[256];							// Keys-Array
bool active = true;						// Window-Active?

bool fs = false;						// Fullscreen?

#define SCREENWIDTH		480				// Size Of Our Window/Resolution
#define SCREENHEIGHT	480				// ...
#define TILESIZE		24				// Textures Size

int map[30][30]= {
	{ 3, 2, 2, 2, 2, 2, 4, 3, 2, 2, 2, 2, 4, 3, 2, 2, 2, 2, 2, 4}, 
	{ 1, 8, 7, 7, 7, 7, 1, 1, 7, 7, 7, 7, 1, 1, 7, 7, 7, 7, 8, 1}, 
	{ 1, 7, 3, 2, 4, 7, 5, 6, 7, 3, 4, 7, 5, 6, 7, 3, 2, 4, 7, 1},  
	{ 1, 7, 1, 0, 1, 7, 7, 7, 7, 1, 1, 7, 7, 7, 7, 1, 0, 1, 7, 1}, 
	{ 1, 7, 5, 2, 6, 7, 2, 2, 2, 6, 5, 2, 2, 2, 7, 5, 2, 6, 7, 1},  
	{ 1, 7, 7, 7, 7, 7, 7, 7, 7, 5, 6, 7, 7, 7, 7, 7, 7, 7, 7, 1}, 
	{ 5, 2, 2, 4, 7, 1, 7, 1, 7, 7, 7, 7, 1, 7, 1, 7, 3, 2, 2, 6},  
	{ 3, 2, 2, 6, 7, 1, 7, 3, 2, 2, 2, 2, 4, 7, 1, 7, 5, 2, 2, 4}, 
	{ 6, 7, 7, 7, 7, 7, 7, 1, 0, 0, 0, 0, 1, 7, 7, 7, 7, 7, 7, 5}, 
	{ 0, 7, 1, 7, 3, 4, 7, 1, 0, 0, 0, 0, 1, 7, 3, 4, 7, 1, 7, 0}, 
	{ 4, 7, 1, 7, 1, 1, 7, 1, 0, 0, 0, 0, 1, 7, 1, 1, 7, 1, 7, 3},  
	{ 1, 7, 7, 7, 1, 1, 7, 5, 2, 0, 0, 2, 6, 7, 1, 1, 7, 7, 7, 1}, 
	{ 5, 2, 4, 7, 1, 1, 7, 7, 7, 7, 7, 7, 7, 7, 1, 1, 7, 3, 2, 6},  
	{ 3, 2, 6, 7, 5, 5, 2, 2, 7, 3, 4, 7, 2, 2, 6, 6, 7, 5, 2, 4},
	{ 1, 7, 7, 7, 7, 7, 7, 7, 7, 1, 1, 7, 7, 7, 7, 7, 7, 7, 7, 1}, 
	{ 1, 7, 3, 2, 4, 7, 2, 2, 2, 6, 5, 2, 2, 2, 7, 3, 2, 4, 7, 1},  
	{ 1, 7, 1, 0, 1, 7, 7, 7, 7, 0, 7, 7, 7, 7, 7, 1, 0, 1, 7, 1}, 
	{ 1, 7, 5, 2, 6, 7, 2, 2, 7, 3, 4, 7, 2, 2, 7, 5, 2, 6, 7, 1},  
	{ 1, 8, 7, 7, 7, 7, 7, 7, 7, 1, 1, 7, 7, 7, 7, 7, 7, 7, 8, 1},
	{ 5, 2, 2, 2, 2, 2, 2, 2, 2, 6, 5, 2, 2, 2, 2, 2, 2, 2, 2, 6},
};

int bak[30][30]= {
	{ 3, 2, 2, 2, 2, 2, 4, 3, 2, 2, 2, 2, 4, 3, 2, 2, 2, 2, 2, 4}, 
	{ 1, 8, 7, 7, 7, 7, 1, 1, 7, 7, 7, 7, 1, 1, 7, 7, 7, 7, 8, 1}, 
	{ 1, 7, 3, 2, 4, 7, 5, 6, 7, 3, 4, 7, 5, 6, 7, 3, 2, 4, 7, 1},  
	{ 1, 7, 1, 0, 1, 7, 7, 7, 7, 1, 1, 7, 7, 7, 7, 1, 0, 1, 7, 1}, 
	{ 1, 7, 5, 2, 6, 7, 2, 2, 2, 6, 5, 2, 2, 2, 7, 5, 2, 6, 7, 1},  
	{ 1, 7, 7, 7, 7, 7, 7, 7, 7, 5, 6, 7, 7, 7, 7, 7, 7, 7, 7, 1}, 
	{ 5, 2, 2, 4, 7, 1, 7, 1, 7, 7, 7, 7, 1, 7, 1, 7, 3, 2, 2, 6},  
	{ 3, 2, 2, 6, 7, 1, 7, 3, 2, 2, 2, 2, 4, 7, 1, 7, 5, 2, 2, 4}, 
	{ 6, 7, 7, 7, 7, 7, 7, 1, 0, 0, 0, 0, 1, 7, 7, 7, 7, 7, 7, 5}, 
	{ 0, 7, 1, 7, 3, 4, 7, 1, 0, 0, 0, 0, 1, 7, 3, 4, 7, 1, 7, 0}, 
	{ 4, 7, 1, 7, 1, 1, 7, 1, 0, 0, 0, 0, 1, 7, 1, 1, 7, 1, 7, 3},  
	{ 1, 7, 7, 7, 1, 1, 7, 5, 2, 0, 0, 2, 6, 7, 1, 1, 7, 7, 7, 1}, 
	{ 5, 2, 4, 7, 1, 1, 7, 7, 7, 7, 7, 7, 7, 7, 1, 1, 7, 3, 2, 6},  
	{ 3, 2, 6, 7, 5, 5, 2, 2, 7, 3, 4, 7, 2, 2, 6, 6, 7, 5, 2, 4},
	{ 1, 7, 7, 7, 7, 7, 7, 7, 7, 1, 1, 7, 7, 7, 7, 7, 7, 7, 7, 1}, 
	{ 1, 7, 3, 2, 4, 7, 2, 2, 2, 6, 5, 2, 2, 2, 7, 3, 2, 4, 7, 1},  
	{ 1, 7, 1, 0, 1, 7, 7, 7, 7, 0, 7, 7, 7, 7, 7, 1, 0, 1, 7, 1}, 
	{ 1, 7, 5, 2, 6, 7, 2, 2, 7, 3, 4, 7, 2, 2, 7, 5, 2, 6, 7, 1},  
	{ 1, 8, 7, 7, 7, 7, 7, 7, 7, 1, 1, 7, 7, 7, 7, 7, 7, 7, 8, 1},
	{ 5, 2, 2, 2, 2, 2, 2, 2, 2, 6, 5, 2, 2, 2, 2, 2, 2, 2, 2, 6},
};



bool gameover;
bool win;		// Show The Win-Screen?
bool lose;		// ?

Player player;

#define POWERUPTIME 4000

Enemy enemy[4];
float enemy_lastmove;
float enemy_delay;
float enemy_lastthink;

//-----------------------------------------------------------------------------
// Name: InitGame()
// Desc: Called To Set Variables Used in The Game 
//-----------------------------------------------------------------------------
void InitGame()
{
	// Initialize The Map....
	for (int loop = 0; loop < 30; loop++)
		for (int loop2 = 0; loop2 < 30; loop2++)
			map[loop][loop2] = bak[loop][loop2];
		
	player.delay = 225.0f;
	player.attackdelay = 200.0f;
	
	player.lastmove = TimerGetTime();
	player.lastpowerup = TimerGetTime() - 30000.0f;

	player.score = 0;

	player.xpos = 9;
	player.ypos = 16;
	player.dir = 0;
	player.nextdir = 0;

	player.flip = false;

	enemy[0].alive = true;
	enemy[0].xpos = 10;
	enemy[0].ypos = 8;
	enemy[0].dir = 3;
	enemy[0].mode = 3;
	enemy[0].texture = 11;

	enemy[1].alive = true;
	enemy[1].xpos = 11;
	enemy[1].ypos = 9;
	enemy[1].dir = 3;
	enemy[1].mode = 3;
	enemy[1].texture = 12;

	enemy[2].alive = true;
	enemy[2].xpos = 8;
	enemy[2].ypos = 10;
	enemy[2].dir = 3;
	enemy[2].mode = 3;
	enemy[2].texture = 13;

	enemy[3].alive = true;
	enemy[3].xpos = 9;
	enemy[3].ypos = 10;
	enemy[3].dir = 3;
	enemy[3].mode = 3;
	enemy[3].texture = 14;

	enemy_lastmove = TimerGetTime();
	enemy_delay = 225.0f;
	
	enemy_lastthink = TimerGetTime()+500.0f;;

	win = false;
	lose = false;
	gameover = true;
}


//-----------------------------------------------------------------------------
// Name: Init()
// Desc: Called Directly After Direct Graphics Runs (Load Textures)
//-----------------------------------------------------------------------------
void Init()
{
	// Load The Textures:
	ppTexture[0] = LoadTexture("Data/leer.tga");
	ppTexture[1] = LoadTexture("Data/linie_senk.tga");
	ppTexture[2] = LoadTexture("Data/linie_waag.tga");
	ppTexture[3] = LoadTexture("Data/bogen_ur.tga");
	ppTexture[4] = LoadTexture("Data/bogen_ul.tga");
	ppTexture[5] = LoadTexture("Data/bogen_or.tga");
	ppTexture[6] = LoadTexture("Data/bogen_ol.tga");
	ppTexture[7] = LoadTexture("Data/punkt.tga");
	ppTexture[8] = LoadTexture("Data/powerup.tga");
	
	ppTexture[9] = LoadTexture("Data/pac0.tga");
	ppTexture[10] = LoadTexture("Data/pac1.tga");

	ppTexture[11] = LoadTexture("Data/enemy1.tga");
	ppTexture[12] = LoadTexture("Data/enemy2.tga");
	ppTexture[13] = LoadTexture("Data/enemy3.tga");
	ppTexture[14] = LoadTexture("Data/enemy4.tga");
	ppTexture[15] = LoadTexture("Data/enemy_fear.tga");

	ppTexture[16] = LoadTexture("Data/gameover.tga");
	ppTexture[17] = LoadTexture("Data/win.tga");

	ppTexture[18] = LoadTexture("Data/pac2.tga");
	ppTexture[19] = LoadTexture("Data/pac3.tga");
	ppTexture[20] = LoadTexture("Data/pac4.tga");

	ppTexture[21] = LoadTexture("Data/lose.tga");
	
} // End Init()

//-----------------------------------------------------------------------------
// Name: Draw()
// Desc: Draws Everything That Will Be On The Screen
//-----------------------------------------------------------------------------
void Draw()
{
	RECT position; // Our Draw-Cursor
	
	// Map
	for (int yloop = 0; yloop < 30; yloop++)
	{
		for (int xloop = 0; xloop < 30; xloop++)
		{
			position.left = TILESIZE*yloop;
			position.top  = TILESIZE*xloop;

			int texture = map[xloop][yloop];

			BltSprite( &position, ppTexture[texture], NULL, NULL);
		}
	}

	// Draw Player
	position.left = TILESIZE*player.xpos;
	position.top  = TILESIZE*player.ypos;
	if (!player.flip)
		BltSprite( &position, ppTexture[9], NULL, NULL);
	else
	{
		if (player.dir == 1)
			BltSprite( &position, ppTexture[10], NULL, NULL);
		else if (player.dir == 2)
			BltSprite( &position, ppTexture[18], NULL, NULL);
		else if (player.dir == 3)
			BltSprite( &position, ppTexture[19], NULL, NULL);
		else if (player.dir == 4)
			BltSprite( &position, ppTexture[20], NULL, NULL);
	}

	if (!gameover)
	{
		// Draw Enemies
		for (int loop = 0; loop < 4; loop++)
		{
			if (enemy[loop].alive)
			{
				position.left = TILESIZE*enemy[loop].xpos;
				position.top  = TILESIZE*enemy[loop].ypos;
				if (TimerGetTime() < player.lastpowerup + POWERUPTIME)
					BltSprite( &position, ppTexture[15], NULL, NULL);
				else
					BltSprite( &position, ppTexture[enemy[loop].texture], NULL, NULL);
			}
		}
	}
	else
	{	// Gameover
		position.left = 112;
		position.top  = 176;
		BltSprite( &position, ppTexture[16], NULL, NULL);
	}

	if (win)
	{	// Won The Game
		position.left = 112;
		position.top  = 310;
		BltSprite( &position, ppTexture[17], NULL, NULL);
	}
	if (lose)
	{	// Lost The Game
		position.left = 112;
		position.top  = 310;
		BltSprite( &position, ppTexture[21], NULL, NULL);
	}
	
} // End Draw()


//-----------------------------------------------------------------------------
// Name: MsgProc()
// Desc: The window's message handler
//-----------------------------------------------------------------------------
LRESULT WINAPI MsgProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam )
{
    switch( msg )
    {
        case WM_ACTIVATE:							// Watch For Window Activate Message
		{
			if (!HIWORD(wParam))					// Check Minimization State
			{
				active=TRUE;						// Program Is Active
			}
			else
			{
				active=FALSE;						// Program Is No Longer Active
			}

			return 0;								// Return To The Message Loop
		}

		case WM_CLOSE:								// Did We Receive A Close Message?
			PostQuitMessage(0);						// Send A Quit Message
			return 0;								// Jump Back
		

        case WM_PAINT:								// Need to Redraw?
            ValidateRect( hWnd, NULL );				// Validate it...
            return 0;								// Jump back
		
		case WM_SYSCOMMAND:							// Intercept System Commands
		{
			switch (wParam)							// Check System Calls
			{
				case SC_SCREENSAVE:					// Screensaver Trying To Start?
				case SC_MONITORPOWER:				// Monitor Trying To Enter Powersave?
				return 0;							// Prevent From Happening
			}
			break;									// Exit
		}

		case WM_KEYDOWN:							// Is A Key Being Held Down?
		{
			keys[wParam] = TRUE;					// If So, Mark It As TRUE
			return 0;								// Jump Back
		}

		case WM_KEYUP:								// Has A Key Been Released?
		{
			keys[wParam] = FALSE;					// If So, Mark It As FALSE
			return 0;								// Jump Back
		}
		
    }

    return DefWindowProc( hWnd, msg, wParam, lParam );
}


//-----------------------------------------------------------------------------
// Name: WinMain()
// Desc: The application's entry point
//-----------------------------------------------------------------------------
INT WINAPI WinMain( HINSTANCE hInst, HINSTANCE, LPSTR, INT )
{
    TimerInit(); // Initialize Our Timer
	srand( (unsigned)TimerGetTime() ); // initializing randomizer with time

	InitGame(); // Initialize The Games Variables
	
	// Register the window class
    WNDCLASSEX wc = { sizeof(WNDCLASSEX), CS_CLASSDC, MsgProc, 0L, 0L, 
                      GetModuleHandle(NULL), LoadIcon(hInst, MAKEINTRESOURCE(103)), NULL, NULL, NULL,
                      "DirectGraphics", NULL };
    RegisterClassEx( &wc );
	
	// Start The Direct-Graphics-Interface:
	if (!CreateDirectGraphicsWindow("DirectPac V0.6", SCREENWIDTH, SCREENHEIGHT, 16, fs))
	{
		KillDirectGraphicsWindow();
		MessageBox( NULL, "Failed To Create Direct Graphics Window!\n --> Error Number 1", "CRITICAL ERROR", MB_ICONERROR);
		return -1;
	}

	//ShowCursor(false);

	// Enter the message loop
    MSG msg; 
    bool done = false;

	while(!done)									// Loop That Runs While done=FALSE
	{
		if (PeekMessage(&msg,NULL,0,0,PM_REMOVE))	// Is There A Message Waiting?
		{
			if (msg.message==WM_QUIT)				// Have We Received A Quit Message?
			{
				done=TRUE;							// If So done=TRUE
			}
			else									// If Not, Deal With Window Messages
			{
				TranslateMessage(&msg);				// Translate The Message
				DispatchMessage(&msg);				// Dispatch The Message
			}
		}
		else										// If There Are No Messages
		{
			// Draw The Scene.  Watch For ESC Key And Quit Messages From DrawGLScene()
			if ((active && !Render()) || keys[VK_ESCAPE])	// Active?  Was There A Quit Received?
			{
				done=TRUE;							// ESC or DrawGLScene Signalled A Quit
			}
			
			if (keys[VK_SPACE] && gameover)
			{
				keys[VK_SPACE] = false;
				InitGame();
				gameover = false;
			}

			if (keys[VK_UP])
				player.nextdir = 1;
			
			if (keys[VK_RIGHT])
				player.nextdir = 2;

			if (keys[VK_DOWN])
				player.nextdir = 3;

			if (keys[VK_LEFT])
				player.nextdir = 4;

			
			if (TimerGetTime() > player.lastmove + player.delay && !gameover)
			{
				bool moved = true; // Have We Moved Him???

				// First Possibility To Change The Dir
				if (player.nextdir == 1 && map[player.ypos-1][player.xpos] == 0 || player.nextdir == 1 && map[player.ypos-1][player.xpos] > 6)
				{
					player.dir = 1;
					player.nextdir = 0;
				}
				else if (player.nextdir == 2 && map[player.ypos][player.xpos+1] == 0 || player.nextdir == 2 && map[player.ypos][player.xpos+1] > 6)
				{
					player.dir = 2;
					player.nextdir = 0;
				}
				else if (player.nextdir == 3 && map[player.ypos+1][player.xpos] == 0 || player.nextdir == 3 && map[player.ypos+1][player.xpos] > 6)
				{
					player.dir = 3;
					player.nextdir = 0;
				}
				else if (player.nextdir == 4 && map[player.ypos][player.xpos-1] == 0 || player.nextdir == 4 && map[player.ypos][player.xpos-1] > 6)
				{
					player.dir = 4;
					player.nextdir = 0;
				}

				player.nextdir = 0;

				// Move Him Depending On His Chosen Direction
				if      (player.dir == 1 && map[player.ypos-1][player.xpos] == 0 || player.dir == 1 && map[player.ypos-1][player.xpos] > 6)
					player.ypos--;
				else if (player.dir == 2 && map[player.ypos][player.xpos+1] == 0 || player.dir == 2 && map[player.ypos][player.xpos+1] > 6)
					player.xpos++;
				else if (player.dir == 3 && map[player.ypos+1][player.xpos] == 0 || player.dir == 3 && map[player.ypos+1][player.xpos] > 6)
					player.ypos++;
				else if (player.dir == 4 && map[player.ypos][player.xpos-1] == 0 || player.dir == 4 && map[player.ypos][player.xpos-1] > 6)
					player.xpos--;

				else // We Could NOT move Him
				{
					/*bool testing = true;
				
					while (testing)
					{
						int tempdir = rand()%(4+1);
					
						if (tempdir == 1 && player.dir != 3 && map[player.ypos-1][player.xpos] == 0 || tempdir == 1 && player.dir != 3 && map[player.ypos-1][player.xpos] > 6)
						{
							player.dir = 1;
							testing = false;
						}
						else if (tempdir == 2 && player.dir != 4 && map[player.ypos][player.xpos+1] == 0 || tempdir == 2 && player.dir != 4 && map[player.ypos][player.xpos+1] > 6)
						{
							player.dir = 2;
							testing = false;
						}
						else if (tempdir == 3 && player.dir != 1 && map[player.ypos+1][player.xpos] == 0 || tempdir == 3 && player.dir != 1 && map[player.ypos+1][player.xpos] > 6)
						{
							player.dir = 3;
							testing = false;
						}
						else if (tempdir == 4 && player.dir != 2 && map[player.ypos][player.xpos-1] == 0 || tempdir == 4 && player.dir != 2 && map[player.ypos][player.xpos-1] > 6)
						{
							player.dir = 4;
							testing = false;
						}						
					} // End While
				*/
					moved = false;
				}
				
				if (moved)
				{
					player.flip = !player.flip; // Texture-Exchange (Make him EAT)
					
					// Kill The Items
					if (map[player.ypos][player.xpos] == 7) // Yellow Point
					{
						map[player.ypos][player.xpos] = 0;
						player.score++;
						PlaySound("data/fressen.wav", NULL, SND_ASYNC);
					}

					else if (map[player.ypos][player.xpos] == 8) // Green Point (powerup)
					{
						map[player.ypos][player.xpos] = 0;
						player.lastpowerup = TimerGetTime();
						player.score++;
						PlaySound("data/powerup.wav", NULL, SND_ASYNC);
					}

					if (player.score == 161) // Collected All Points
					{
						gameover = true;
						win = true;
					}

					// Teleporter:
					if (player.xpos > 19)
					{
						PlaySound("data/teleport.wav", NULL, SND_ASYNC);
						player.xpos = 0;
					}
					else if (player.xpos < 1)
					{
						PlaySound("data/teleport.wav", NULL, SND_ASYNC);
						player.xpos = 19;
					}


					// Set Time
					player.lastmove = TimerGetTime(); // Done Moving

					// Change Time If Powerup
					if (TimerGetTime() < player.lastpowerup + POWERUPTIME)
						player.lastmove = TimerGetTime() - (player.delay - player.attackdelay); 

				}
			} // End if Time..


			if (TimerGetTime() > enemy_lastthink + 1000.0f && !gameover)
			{
				// Make Enemies Think About Their Situtaion
				for (int loop = 0; loop < 4; loop++)
				{
					if (TimerGetTime() < player.lastpowerup + POWERUPTIME)
						enemy[loop].mode = 2;

					else if (rand()%10 > 6)
						enemy[loop].mode = 3;

					else
						enemy[loop].mode = 1;
				}
			}

		
			if (TimerGetTime() > enemy_lastmove + enemy_delay && !gameover)
			{
				// Move Enemies
				for (int loop = 0; loop < 4; loop++)
				{
					
					if (enemy[loop].mode == 1)
					{
						if (rand()%10 > 6)
						{
							bool testing = true;
						
							while (testing)
							{
								int tempdir = rand()%(4+1);
							
								if (tempdir == 1 && enemy[loop].dir != 3 && map[enemy[loop].ypos-1][enemy[loop].xpos] == 0 || tempdir == 1 && enemy[loop].dir != 3 && map[enemy[loop].ypos-1][enemy[loop].xpos] > 6)
								{
									enemy[loop].dir = 1;
									testing = false;
								}
								else if (tempdir == 2 && enemy[loop].dir != 4 && map[enemy[loop].ypos][enemy[loop].xpos+1] == 0 || tempdir == 2 && enemy[loop].dir != 4 && map[enemy[loop].ypos][enemy[loop].xpos+1] > 6)
								{
									enemy[loop].dir = 2;
									testing = false;
								}
								else if (tempdir == 3 && enemy[loop].dir != 1 && map[enemy[loop].ypos+1][enemy[loop].xpos] == 0 || tempdir == 3 && enemy[loop].dir != 1 && map[enemy[loop].ypos+1][enemy[loop].xpos] > 6)
								{
									enemy[loop].dir = 3;
									testing = false;
								}
								else if (tempdir == 4 && enemy[loop].dir != 2 && map[enemy[loop].ypos][enemy[loop].xpos-1] == 0 || tempdir == 4 && enemy[loop].dir != 2 && map[enemy[loop].ypos][enemy[loop].xpos-1] > 6)
								{
									enemy[loop].dir = 4;
									testing = false;
								}						
							} // End While
						}

					
						if      (enemy[loop].dir == 1 && map[enemy[loop].ypos-1][enemy[loop].xpos] == 0 || enemy[loop].dir == 1 && map[enemy[loop].ypos-1][enemy[loop].xpos] > 6)
							enemy[loop].ypos--;
						else if (enemy[loop].dir == 2 && map[enemy[loop].ypos][enemy[loop].xpos+1] == 0 || enemy[loop].dir == 2 && map[enemy[loop].ypos][enemy[loop].xpos+1] > 6)
							enemy[loop].xpos++;
						else if (enemy[loop].dir == 3 && map[enemy[loop].ypos+1][enemy[loop].xpos] == 0 || enemy[loop].dir == 3 && map[enemy[loop].ypos+1][enemy[loop].xpos] > 6)
							enemy[loop].ypos++;
						else if (enemy[loop].dir == 4 && map[enemy[loop].ypos][enemy[loop].xpos-1] == 0 || enemy[loop].dir == 4 && map[enemy[loop].ypos][enemy[loop].xpos-1] > 6)
							enemy[loop].xpos--;
					}

					else if (enemy[loop].mode == 2)	// Get Away
					{
						int random = rand()%10;
						bool moved = true;

						if (random < 6)
						{
							if (player.xpos <= enemy[loop].xpos && map[enemy[loop].ypos][enemy[loop].xpos+1] == 0 ||
								player.xpos <= enemy[loop].xpos && map[enemy[loop].ypos][enemy[loop].xpos+1] >6)
								enemy[loop].xpos++;
							else if (player.xpos >= enemy[loop].xpos && map[enemy[loop].ypos][enemy[loop].xpos-1] == 0 ||
								player.xpos <= enemy[loop].xpos && map[enemy[loop].ypos][enemy[loop].xpos-1] >6)
								enemy[loop].xpos--;
							else
								moved = false;
						}
						else
						{
							if (player.ypos <= enemy[loop].ypos && map[enemy[loop].ypos+1][enemy[loop].xpos] == 0 ||
								player.ypos <= enemy[loop].ypos && map[enemy[loop].ypos+1][enemy[loop].xpos] >6)
								enemy[loop].ypos++;
							else if (player.ypos >= enemy[loop].ypos && map[enemy[loop].ypos-1][enemy[loop].xpos] == 0 ||
									 player.ypos <= enemy[loop].ypos && map[enemy[loop].ypos-1][enemy[loop].xpos] >6)
									 enemy[loop].ypos--;
							else 
								moved = false;
						}

						if (!moved)
						{
							bool testing = true;
						
							while (testing)
							{
								int tempdir = rand()%(4+1);
							
								if (tempdir == 1 && enemy[loop].dir != 3 && map[enemy[loop].ypos-1][enemy[loop].xpos] == 0 || tempdir == 1 && enemy[loop].dir != 3 && map[enemy[loop].ypos-1][enemy[loop].xpos] > 6)
								{
									enemy[loop].dir = 1;
									testing = false;
								}
								else if (tempdir == 2 && enemy[loop].dir != 4 && map[enemy[loop].ypos][enemy[loop].xpos+1] == 0 || tempdir == 2 && enemy[loop].dir != 4 && map[enemy[loop].ypos][enemy[loop].xpos+1] > 6)
								{
									enemy[loop].dir = 2;
									testing = false;
								}
								else if (tempdir == 3 && enemy[loop].dir != 1 && map[enemy[loop].ypos+1][enemy[loop].xpos] == 0 || tempdir == 3 && enemy[loop].dir != 1 && map[enemy[loop].ypos+1][enemy[loop].xpos] > 6)
								{
									enemy[loop].dir = 3;
									testing = false;
								}
								else if (tempdir == 4 && enemy[loop].dir != 2 && map[enemy[loop].ypos][enemy[loop].xpos-1] == 0 || tempdir == 4 && enemy[loop].dir != 2 && map[enemy[loop].ypos][enemy[loop].xpos-1] > 6)
								{
									enemy[loop].dir = 4;
									testing = false;
								}						
							} // End While
						}

					} 

					else if (enemy[loop].mode == 3)	// ATTACK
					{
						int random = rand()%10;
						
						if (random < 6)
						{
							if (player.xpos >= enemy[loop].xpos && map[enemy[loop].ypos][enemy[loop].xpos+1] == 0 ||
								player.xpos >= enemy[loop].xpos && map[enemy[loop].ypos][enemy[loop].xpos+1] >6)
								enemy[loop].xpos++;
							else if (player.xpos >= enemy[loop].xpos && map[enemy[loop].ypos][enemy[loop].xpos-1] == 0 ||
								player.xpos >= enemy[loop].xpos && map[enemy[loop].ypos][enemy[loop].xpos-1] >6)
								enemy[loop].xpos--;
						}
						else
						{
							if (player.ypos >= enemy[loop].ypos && map[enemy[loop].ypos+1][enemy[loop].xpos] == 0 ||
								player.ypos >= enemy[loop].ypos && map[enemy[loop].ypos+1][enemy[loop].xpos] >6)
								enemy[loop].ypos++;
							else if (player.ypos <= enemy[loop].ypos && map[enemy[loop].ypos-1][enemy[loop].xpos] == 0 ||
									 player.ypos <= enemy[loop].ypos && map[enemy[loop].ypos-1][enemy[loop].xpos] >6)
									 enemy[loop].ypos--;
								
						}
					} 
					
					
				} // End-Loop
				enemy_lastmove = TimerGetTime();
			}


			for (int loop = 0; loop < 4; loop++)
			{
				// Collision-Detection
				if (enemy[loop].alive && player.xpos == enemy[loop].xpos && player.ypos == enemy[loop].ypos)
				{
					if (TimerGetTime() < player.lastpowerup + POWERUPTIME)
					{
						enemy[loop].alive = false;
						PlaySound("data/kill.wav", NULL, SND_ASYNC);
					}				
					else
					{
						gameover = true;
						lose = true;
						
					}
				}
			}
		
		}
	}
		
    // Clean up everything and exit the app
    KillDirectGraphicsWindow();
	UnregisterClass( "DirectGraphics", wc.hInstance );	// We Do Not Need The Class Any More!
	ShowCursor(true);    
	return 0;
} // End Main()
